#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "PCD8544.h"
#include <stdio.h>
#include <stdlib.h>

static unsigned char playerX , playerY;

int coliziune ( int x1, int y1 )
{
	unsigned char i, j;
	int x, y;


	for(j = 0; j < 3; j++){
	x = x1 * 3 + j;
	y = y1 * 3 + j;
	//	down and up borders
	for ( i = 0; i < WIDTH; i++ )
	{
		if( (x == i && y == 0) || (x == i && y == 1) || 
			(x == i && y == HEIGHT - 1) || (x == i && y == HEIGHT - 2))
			return 1;
	}
	
	//	left and right
	for ( i = 0; i < HEIGHT; i ++ )
	{
		if( (x == 0 && y == i) || (x ==1 && y == i) || 
			(x == WIDTH - 1 && y == i) || (x == WIDTH - 2 && y == i))
			return 1;
	}

	for ( i = 0 ; i < HEIGHT/6 - 1; i ++ )
	{
		if( (x == 9 && y == i + HEIGHT/3 - 2) || (x == 9 && y == i + HEIGHT/2 - 3) || 
			(x == 9 && y == 5 * HEIGHT/6 - 5) || (x ==9 && y == i + HEIGHT - 6))
			return 1;

		if( (x == WIDTH/4 - 4 && y == i + HEIGHT/6 - 1) || 
			(x == WIDTH/4 - 4 && y == i + 2 * HEIGHT/3 - 4) || 
			(x == WIDTH/4 - 4 && y == i + 5 * HEIGHT/6 - 5))
			return 1;

		if( (x == WIDTH/4 + 5 && y == i + 1) || 
			(x == WIDTH/4 + 5 && y == i + HEIGHT/3 - 2) || 
			(x == WIDTH/4 + 5 && y == i + HEIGHT/2 - 3) || 
			(x == WIDTH/4 + 5 && y == i + 5 * HEIGHT/6 - 5))
			return 1;

		if( (x == WIDTH/2 - 7 && y == i + HEIGHT/6 - 1) || 
			(x == WIDTH/2 - 7 && y == i + 2 * HEIGHT/3 - 4) || 
			(x == WIDTH/2 - 7 && y == i + 5 * HEIGHT/6 - 5))
			return 1;

		if( (x == WIDTH/2 + 2 && y == i) || 
			(x == WIDTH/2 + 2 && y == i + HEIGHT/3 - 2) || 
			(x == WIDTH/2 + 2 && y == i + HEIGHT/2 - 3) || 
			(x == WIDTH/2 + 2 && y == i + 2 * HEIGHT/3 - 4))
			return 1;

		if( (x == WIDTH/2 + 10 && y == i) || 
			(x == WIDTH/2 + 10 && y == i + HEIGHT/6 - 1) || 
			(x == WIDTH/2 + 10 && y == i + HEIGHT/3 - 2) || 
			(x == WIDTH/2 + 10 && y == i + 2 * HEIGHT/3 - 4) ||
			(x == WIDTH/2 + 10 && y == i + 5 * HEIGHT/6 - 5) || 
			(x == WIDTH/2 + 10 && y == i + HEIGHT - 6))
			return 1;

		if( (x == WIDTH/2 + 17 && y == i + HEIGHT/3 - 2) || 
			(x == WIDTH/2 + 17 && y == i + HEIGHT/2 - 3) || 
			(x == WIDTH/2 + 17 && y == i + 2 * HEIGHT/3 - 4))
			return 1;
		if( (x == WIDTH - 17 && y == i + HEIGHT/2 - 3) || 
			(x == WIDTH - 17 && y == i + 2 * HEIGHT/3 - 4) || 
			(x == WIDTH - 17 && y == i + 5 * HEIGHT/6 - 5))
			return 1;

		if( (x == WIDTH - 9 && y == i + HEIGHT/6 - 1) || 
			(x == WIDTH - 9 && y == i + HEIGHT/3 - 2) || 
			(x == WIDTH - 9 && y == i + 2 * HEIGHT/3 - 4) || 
			(x == WIDTH - 9 && y == i + 5 * HEIGHT/6 - 5))
			return 1;
		
	}

	for ( i = 0; i < WIDTH/12 + 1; i++ )
	{
		if( (x == i + WIDTH/12 + 3 && y == HEIGHT/6 - 1) || 
			(x == i + 2 * WIDTH/12 + 4 && y == HEIGHT/6 - 1) || 
			(x == i + WIDTH/2 + 2 && y == HEIGHT/6 - 1) || 
			(x == i + WIDTH/2 + 17 && y == HEIGHT/6 - 1) || 
			(x == i + WIDTH/2 + WIDTH/12 + 18 && y == HEIGHT/6 - 1))
			return 1;

		if( (x == i + 2 && y == HEIGHT/3 - 2) || 
			(x == i + WIDTH/4 + 5 && y == HEIGHT/3 - 2) || 
			(x == i + WIDTH/4 + WIDTH/12 + 2 && y == HEIGHT/3 - 2) || 
			(x == i + WIDTH/4 + 2 * WIDTH/12 + 2 && y ==  HEIGHT/3 - 2) ||
			(x == i + WIDTH/2 + 17 && y == HEIGHT/3 - 2) || 
			(x == i + WIDTH/2 + WIDTH/12 + 18 && y == HEIGHT/3 - 2))
			return 1;

		if( (x == i + 10 && y == HEIGHT/2 - 3) || (x == i + WIDTH/12 + 11 && y == HEIGHT/2 - 3) || 
			(x == i + WIDTH/2 - 6 && y == HEIGHT/2 - 3))
			return 1;

		if( (x == i + 10 && y == 5 * HEIGHT/6 - 5) || 
			(x == i + WIDTH/4 + 6 && y == 5 * HEIGHT/6 - 5))
			return 1;

		if( (x == i + WIDTH/2 + 10 && y == 2 * HEIGHT/3 - 4) || 
			(x == i + WIDTH - 17 && y == 2 * HEIGHT/3 - 4))
			return 1;

		if( (x == i + WIDTH/4 - 3 && y == HEIGHT - 7) || 
			(x == i + WIDTH/2 + 2 && y == HEIGHT - 7) || 
			(x == i + WIDTH - 9 && y == HEIGHT - 7))
			return 1;
	}
	}	
	return 0;
}

int main(void)
{
	LCD_init();

	while ( 1 )
	{
		DDRD = 0b10000000;
		PORTD=0b01111111;

		LCD_clear();

		//	local variables
		unsigned char left = 0, right = 0 , up = 0 , down = 0;

		playerX = 1 ;
		playerY = 1 ;

		LCD_border_and_score( );
		unsigned char aa = 0;
		while ( 1 )
		{
			//contor ++ ;

			LCD_clear3pixel( playerX , playerY , 0 , 0 , 1 );

			//aprind led ul de pe placa de baza
			if ( ( PIND | 0b10111111 ) == 0b10111111 )	//	pressed
			{
				aa = 1;
			}
			else if ( aa )	//	released
			{
				aa = 0;
			PORTD = ~(PORTD ^ 0b01111111);
		
			}

			if ( ( PIND | 0b11011111 ) == 0b11011111 )	//	pressed
			{
				left = 1;
			}
			else if ( left )	//	released
			{
				left = 0;
				if( !coliziune( playerX - 1, playerY) )
					playerX = playerX - 1 >= 0 ? playerX - 1 : 0 ;
			}

			if ( ( PIND | 0b11101111 ) == 0b11101111 )
			{
				down = 1;
			}
			else if ( down )
			{
				down = 0;
				if( !coliziune( playerX, playerY + 1) )
					playerY = playerY + 1 < HEIGHT ? playerY + 1 : HEIGHT - 1 ;
			}

			if ( ( PIND | 0b11111101 ) == 0b11111101 )
			{
				up = 1;
			}
			else if ( up )
			{
				up = 0 ;
				if( !coliziune( playerX, playerY - 1) )
					playerY = playerY - 1 >= 0 ? playerY - 1 : 0 ;
			}

			if ( ( PIND | 0b11111110 ) == 0b11111110 )
			{
				right = 1;
			}
			else if ( right )
			{
				right = 0;
				if( !coliziune( playerX + 1, playerY) )
					playerX = playerX + 1 < WIDTH ? playerX + 1 : WIDTH - 1 ;
			}

			LCD_set3pixel ( playerX , playerY , 0 , 0 , 1 );
			delay(100);
		}

		LCD_clear();

		delay (10000);
		delay (10000);
		delay (10000);
	}

	return 0;
}
