/*
** lcd.h
**
** LCD 3310 driver
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 84
#define LCD_Y_RES 48
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)

#define WIDTH 84
#define HEIGHT 48

/* Pinout for LCD */
#define LCD_CLK_PIN 	(1<<PB7)
#define LCD_DATA_PIN 	(1<<PB5)
#define LCD_DC_PIN 		(1<<PB4)
#define LCD_CE_PIN 		(1<<PB0)
#define LCD_RST_PIN 	(1<<PB6)
#define LCD_PORT		PORTB
#define LCD_DDR			DDRB

/* Special Chars */
#define ARROW_RIGHT	ICON(0)
#define ARROW_LEFT 	ICON(1)
#define ARROW_UP 	ICON(2)
#define ARROW_DOWN 	ICON(3)
#define STOP 		ICON(4)
#define PLAY	 	ICON(5)

/* Function for my special characters */
#define	ICON(x)		'z'+1+x

/* delay macro function */
//#define LCD_delay() for(char i = 0; i < 20; i++) for(char j = 0; j < 100; j++){asm("nop");asm("nop");}
/* delay macro function */
#define LCD_delay() for(int i=-32000;i<32000;i++)


/**
  *	Functiile exportate de driver
  */
#define SELECTED   		1
#define NOT_SELECTED 	0

void LCD_init(void);
void LCD_raw( const char  * splash, uint16_t len );
void LCD_str( char* str,uint8_t sel);
void LCD_clear(void);
void LCD_contrast(unsigned char contrast);
void LCD_gotoXY(uint8_t x, uint8_t y);


void LCD_setpixel(unsigned char x, unsigned char y);
void LCD_clear3pixel( unsigned char i , unsigned char j , unsigned char offsetX , unsigned char offsetY , unsigned char full );
void LCD_set3pixel( unsigned char i , unsigned char j , unsigned char offsetX , unsigned char offsetY , unsigned char full );
void LCD_border_and_score ( void );

#endif



